VERSION 5.00
Begin VB.UserControl Rocket 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   PropertyPages   =   "Rocket.ctx":0000
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.CommandButton Rocket 
      Caption         =   "Bitwise 1"
      Height          =   855
      Left            =   1080
      TabIndex        =   0
      Top             =   1080
      Width           =   1815
   End
End
Attribute VB_Name = "Rocket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
 '
 ' Visual Basic Sample Code provided by BITWISE MAGAZINE
 '
 '      http://www.bitwisemag.com
 '
 ' This code and information is provided "as is" without warranty of
 ' any kind, either expressed or implied, including but not limited
 ' to the implied warranties of merchantability and/or fitness for a
 ' particular purpose.
 '
 ' You may use and modify this code for your personal use only.
 ' You may also redistribute this code providing that
 ' a) No fee is charged
 ' b) This copyright notice is retained in the source code.
 '
 ' You may not use this code for commercial purposes
 ' without the express permission of the copyright holder
 '
 ' Copyright (c) 2006 Dermot Hogan
 '
 '
Option Explicit

Dim vv, vh, alpha, pi As Double
Const g = 9.81
'Default Property Values:
Const m_def_InitialVelocity = 0
Const m_def_InitialAngle = 45
'Property Variables:
Dim m_InitialVelocity As Double
Dim m_InitialAngle As Double

Private Sub UserControl_Resize()
Rocket.Move 0, 0, ScaleWidth, ScaleHeight

End Sub
Public Sub Tick()

If Extender.Container.Ground.Y1 >= Extender.Top + Height Then
    Extender.Top = Extender.Top - vv
    vv = vv - g
    Extender.Left = Extender.Left + vh
    DoEvents
End If


End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_InitialVelocity = m_def_InitialVelocity
    m_InitialAngle = m_def_InitialAngle
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_InitialVelocity = PropBag.ReadProperty("InitialVelocity", m_def_InitialVelocity)
    m_InitialAngle = PropBag.ReadProperty("InitialAngle", m_def_InitialAngle)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("InitialVelocity", m_InitialVelocity, m_def_InitialVelocity)
    Call PropBag.WriteProperty("InitialAngle", m_InitialAngle, m_def_InitialAngle)
End Sub

Public Function Initialize() As Boolean

'convert the angle from degrees to radians
pi = Atn(1) * 4
alpha = m_InitialAngle / 180 * pi
' calculate the horizontal and vertical components
vh = m_InitialVelocity * Cos(alpha)
vv = m_InitialVelocity * Sin(alpha)
' set the rocket on the ground
Extender.Top = Extender.Container.Ground.Y1 - Height
Extender.Left = Extender.Container.Ground.X1

End Function
Public Property Get InitialVelocity() As Double
Attribute InitialVelocity.VB_ProcData.VB_Invoke_Property = "Settings"
    InitialVelocity = m_InitialVelocity
End Property

Public Property Let InitialVelocity(ByVal New_InitialVelocity As Double)
    m_InitialVelocity = New_InitialVelocity
    PropertyChanged "InitialVelocity"
End Property

Public Property Get InitialAngle() As Double
Attribute InitialAngle.VB_ProcData.VB_Invoke_Property = "Settings"
    InitialAngle = m_InitialAngle
End Property

Public Property Let InitialAngle(ByVal New_InitialAngle As Double)
    m_InitialAngle = New_InitialAngle
    PropertyChanged "InitialAngle"
End Property

